/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Sat Jul  1 09:18:20 EST 2000
    copyright            : (C) 2000 by Ashley Cambrell
    email                : bec_ash@bigpond.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*** contactforce2 */
/* example-start tictactoe ttt_test.c */

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "cfdb.h"

void moved( GtkWidget *widget,
          gpointer   data )
{
  g_print ("########Moved Sgnal!\n");
}

void delete_lookup(GtkWidget *widget, gpointer data)
{
	cfdb_remove_all_lookup_criteria(GTK_WIDGET(data));
	cfdb_reload(data);
}

void reload( GtkWidget *widget, gpointer   data )
{
	cfdb_reload(data);
}

void reload_continue( GtkWidget *widget, gpointer   data )
{
	g_print("reload_continue\n");
	cfdb_reload_continue(data);
}


int main( int   argc, char *argv[] )
{
  GtkWidget *window;
  GtkWidget *cf1, *cf2;//, *cf3;
  GtkWidget *vbox, *vbox2;
  GtkWidget *text1,*text2, *text3, *text4, *text5;
  GtkWidget *button, *button2, *button3, *button4;
	GtkWidget *frame;
//  GtkWidget *scroll, *clist;
//  gchar *titles[2] = { "FirstName", "Surname" };
//  gchar **fields;
//  int i;

  gtk_init (&argc, &argv);

 	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "Aspect Frame");

  gtk_container_set_border_width (GTK_CONTAINER (window), 10);
  vbox = gtk_vbox_new(FALSE, 5);
  gtk_container_add(GTK_CONTAINER(window),vbox);

  cf1 = cfdb_new("host=server.ash.net.au user=ash dbname=cfdb-test","uid","client");

	text1 = gtk_entry_new();
	text2 = gtk_entry_new();
	text3 = gtk_entry_new();
	
  //clist = gtk_clist_new_with_titles( 2, titles);

	cfdb_add_field_widget_map (cf1, "fname", text1);
	cfdb_add_field_widget_map (cf1, "sname", text2);
	cfdb_add_field_widget_map (cf1, "email", text3);

	button = gtk_button_new_with_label("Reload Cf1");
	button2 = gtk_button_new_with_label("Reload Same Place");
	button3 = gtk_button_new_with_label("Insert");
	button4 = gtk_button_new_with_label("Remove lookup criteria");

  gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_exit), NULL);	

	gtk_signal_connect(GTK_OBJECT(button), "clicked",  GTK_SIGNAL_FUNC(reload), cf1);

	gtk_signal_connect(GTK_OBJECT(button2), "clicked",  GTK_SIGNAL_FUNC(reload_continue), cf1);
	gtk_signal_connect(GTK_OBJECT(button3), "clicked",  GTK_SIGNAL_FUNC(cfdb_set_insert_mode), cf1);
	gtk_signal_connect(GTK_OBJECT(button4), "clicked",  GTK_SIGNAL_FUNC(delete_lookup), cf1);
	

  //gtk_widget_show (scroll);
	//gtk_widget_show(clist);
		
  gtk_signal_connect (GTK_OBJECT (cf1), "moved", GTK_SIGNAL_FUNC (moved), NULL);

  /* for testing, set a temporary lookup where email is like sales */	
	cfdb_add_lookup_criteria(cf1,LOOKUP_AND,"email","sales");
	
	/* persistant lookups are used in situations where enforced (by code) restrictions on results
	eg.  for a muti-user contact database where you only want the users records and any public records
	to be seen.  There are not cleared by cfdb_remove_lookup
	*/
	cfdb_add_persistant_lookup_criteria(cf1,LOOKUP_OR,"ispublic","t");
	cfdb_add_persistant_lookup_criteria(cf1,LOOKUP_OR,"owner","Billy");

	frame = gtk_frame_new(NULL);
 	gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_ETCHED_IN);

 	gtk_widget_show(frame);
 	
 	gtk_frame_set_label(GTK_FRAME(frame),"Payments");
  vbox2 = gtk_vbox_new(FALSE, 3);

  gtk_container_add(GTK_CONTAINER(frame),vbox2);

  /* setup another test widget for a relational setup */
  cf2 = cfdb_new("host=server.ash.net.au user=ash dbname=cfdb-test","pid","payments");
	cfdb_add_field_widget_map (cf1, "uid", cf2);


	text4 = gtk_entry_new();
	text5 = gtk_entry_new();

	cfdb_add_field_widget_map (cf2, "amount", text4);
	cfdb_add_field_widget_map (cf2, "description", text5);

  gtk_box_pack_start(GTK_BOX(vbox), cf1, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox), text1, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox), text2, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox), text3, FALSE, FALSE, 2);

  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 2);

  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox), button2, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox), button3, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox), button4, FALSE, FALSE, 2);

  gtk_box_pack_start(GTK_BOX(vbox2), cf2, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox2), text4, FALSE, FALSE, 2);
  gtk_box_pack_start(GTK_BOX(vbox2), text5, FALSE, FALSE, 2);

  gtk_widget_show (vbox);
	gtk_widget_show(button);
	gtk_widget_show(button2);
	gtk_widget_show(button3);
	gtk_widget_show(button4);
	
	gtk_widget_show(text1);
	gtk_widget_show(text2);
	gtk_widget_show(text3);	
  gtk_widget_show (cf1);

	gtk_widget_show(text4);
	gtk_widget_show(text5);
  gtk_widget_show (cf2);
  gtk_widget_show (vbox2);
  	
  /* start the ball rolling */ 	
	cfdb_start(cf1);
	
  gtk_widget_show (window);

  gtk_main ();

  return 0;
}


/* example-end */



/* contactforce2 ***/
